=begin
#Pulp 3 API

#Fetch, Upload, Organize, and Distribute Software Packages

The version of the OpenAPI document: v3
Contact: pulp-list@redhat.com
Generated by: https://openapi-generator.tech
OpenAPI Generator version: 4.2.3

=end

require 'cgi'

module PulpcoreClient
  class GroupsApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Create a group
    # ViewSet for Group.  NOTE: This API endpoint is in \"tech preview\" and subject to change
    # @param group [Group] 
    # @param [Hash] opts the optional parameters
    # @return [GroupResponse]
    def create(group, opts = {})
      data, _status_code, _headers = create_with_http_info(group, opts)
      data
    end

    # Create a group
    # ViewSet for Group.  NOTE: This API endpoint is in \&quot;tech preview\&quot; and subject to change
    # @param group [Group] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(GroupResponse, Integer, Hash)>] GroupResponse data, response status code and response headers
    def create_with_http_info(group, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: GroupsApi.create ...'
      end
      # verify the required parameter 'group' is set
      if @api_client.config.client_side_validation && group.nil?
        fail ArgumentError, "Missing the required parameter 'group' when calling GroupsApi.create"
      end
      # resource path
      local_var_path = '/pulp/api/v3/groups/'

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] || @api_client.object_to_http_body(group) 

      # return_type
      return_type = opts[:return_type] || 'GroupResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:POST, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: GroupsApi#create\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Delete a group
    # ViewSet for Group.  NOTE: This API endpoint is in \"tech preview\" and subject to change
    # @param auth_group_href [String] 
    # @param [Hash] opts the optional parameters
    # @return [nil]
    def delete(auth_group_href, opts = {})
      delete_with_http_info(auth_group_href, opts)
      nil
    end

    # Delete a group
    # ViewSet for Group.  NOTE: This API endpoint is in \&quot;tech preview\&quot; and subject to change
    # @param auth_group_href [String] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(nil, Integer, Hash)>] nil, response status code and response headers
    def delete_with_http_info(auth_group_href, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: GroupsApi.delete ...'
      end
      # verify the required parameter 'auth_group_href' is set
      if @api_client.config.client_side_validation && auth_group_href.nil?
        fail ArgumentError, "Missing the required parameter 'auth_group_href' when calling GroupsApi.delete"
      end
      # resource path
      local_var_path = '{auth_group_href}'.sub('{' + 'auth_group_href' + '}', CGI.escape(auth_group_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: GroupsApi#delete\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # List groups
    # ViewSet for Group.  NOTE: This API endpoint is in \"tech preview\" and subject to change
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :limit Number of results to return per page.
    # @option opts [Integer] :offset The initial index from which to return the results.
    # @option opts [String] :ordering Which field to use when ordering the results.
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [PaginatedGroupResponseList]
    def list(opts = {})
      data, _status_code, _headers = list_with_http_info(opts)
      data
    end

    # List groups
    # ViewSet for Group.  NOTE: This API endpoint is in \&quot;tech preview\&quot; and subject to change
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :limit Number of results to return per page.
    # @option opts [Integer] :offset The initial index from which to return the results.
    # @option opts [String] :ordering Which field to use when ordering the results.
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [Array<(PaginatedGroupResponseList, Integer, Hash)>] PaginatedGroupResponseList data, response status code and response headers
    def list_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: GroupsApi.list ...'
      end
      # resource path
      local_var_path = '/pulp/api/v3/groups/'

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'limit'] = opts[:'limit'] if !opts[:'limit'].nil?
      query_params[:'offset'] = opts[:'offset'] if !opts[:'offset'].nil?
      query_params[:'ordering'] = opts[:'ordering'] if !opts[:'ordering'].nil?
      query_params[:'fields'] = opts[:'fields'] if !opts[:'fields'].nil?
      query_params[:'exclude_fields'] = opts[:'exclude_fields'] if !opts[:'exclude_fields'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'PaginatedGroupResponseList' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: GroupsApi#list\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Update a group
    # ViewSet for Group.  NOTE: This API endpoint is in \"tech preview\" and subject to change
    # @param auth_group_href [String] 
    # @param patched_group [PatchedGroup] 
    # @param [Hash] opts the optional parameters
    # @return [GroupResponse]
    def partial_update(auth_group_href, patched_group, opts = {})
      data, _status_code, _headers = partial_update_with_http_info(auth_group_href, patched_group, opts)
      data
    end

    # Update a group
    # ViewSet for Group.  NOTE: This API endpoint is in \&quot;tech preview\&quot; and subject to change
    # @param auth_group_href [String] 
    # @param patched_group [PatchedGroup] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(GroupResponse, Integer, Hash)>] GroupResponse data, response status code and response headers
    def partial_update_with_http_info(auth_group_href, patched_group, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: GroupsApi.partial_update ...'
      end
      # verify the required parameter 'auth_group_href' is set
      if @api_client.config.client_side_validation && auth_group_href.nil?
        fail ArgumentError, "Missing the required parameter 'auth_group_href' when calling GroupsApi.partial_update"
      end
      # verify the required parameter 'patched_group' is set
      if @api_client.config.client_side_validation && patched_group.nil?
        fail ArgumentError, "Missing the required parameter 'patched_group' when calling GroupsApi.partial_update"
      end
      # resource path
      local_var_path = '{auth_group_href}'.sub('{' + 'auth_group_href' + '}', CGI.escape(auth_group_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] || @api_client.object_to_http_body(patched_group) 

      # return_type
      return_type = opts[:return_type] || 'GroupResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:PATCH, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: GroupsApi#partial_update\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Inspect a group
    # ViewSet for Group.  NOTE: This API endpoint is in \"tech preview\" and subject to change
    # @param auth_group_href [String] 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [GroupResponse]
    def read(auth_group_href, opts = {})
      data, _status_code, _headers = read_with_http_info(auth_group_href, opts)
      data
    end

    # Inspect a group
    # ViewSet for Group.  NOTE: This API endpoint is in \&quot;tech preview\&quot; and subject to change
    # @param auth_group_href [String] 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [Array<(GroupResponse, Integer, Hash)>] GroupResponse data, response status code and response headers
    def read_with_http_info(auth_group_href, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: GroupsApi.read ...'
      end
      # verify the required parameter 'auth_group_href' is set
      if @api_client.config.client_side_validation && auth_group_href.nil?
        fail ArgumentError, "Missing the required parameter 'auth_group_href' when calling GroupsApi.read"
      end
      # resource path
      local_var_path = '{auth_group_href}'.sub('{' + 'auth_group_href' + '}', CGI.escape(auth_group_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'fields'] = opts[:'fields'] if !opts[:'fields'].nil?
      query_params[:'exclude_fields'] = opts[:'exclude_fields'] if !opts[:'exclude_fields'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'GroupResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: GroupsApi#read\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Update a group
    # ViewSet for Group.  NOTE: This API endpoint is in \"tech preview\" and subject to change
    # @param auth_group_href [String] 
    # @param group [Group] 
    # @param [Hash] opts the optional parameters
    # @return [GroupResponse]
    def update(auth_group_href, group, opts = {})
      data, _status_code, _headers = update_with_http_info(auth_group_href, group, opts)
      data
    end

    # Update a group
    # ViewSet for Group.  NOTE: This API endpoint is in \&quot;tech preview\&quot; and subject to change
    # @param auth_group_href [String] 
    # @param group [Group] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(GroupResponse, Integer, Hash)>] GroupResponse data, response status code and response headers
    def update_with_http_info(auth_group_href, group, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: GroupsApi.update ...'
      end
      # verify the required parameter 'auth_group_href' is set
      if @api_client.config.client_side_validation && auth_group_href.nil?
        fail ArgumentError, "Missing the required parameter 'auth_group_href' when calling GroupsApi.update"
      end
      # verify the required parameter 'group' is set
      if @api_client.config.client_side_validation && group.nil?
        fail ArgumentError, "Missing the required parameter 'group' when calling GroupsApi.update"
      end
      # resource path
      local_var_path = '{auth_group_href}'.sub('{' + 'auth_group_href' + '}', CGI.escape(auth_group_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] || @api_client.object_to_http_body(group) 

      # return_type
      return_type = opts[:return_type] || 'GroupResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:PUT, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: GroupsApi#update\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
