=begin
#Pulp 3 API

#Fetch, Upload, Organize, and Distribute Software Packages

The version of the OpenAPI document: v3
Contact: pulp-list@redhat.com
Generated by: https://openapi-generator.tech
OpenAPI Generator version: 4.2.3

=end

require 'cgi'

module PulpcoreClient
  class UploadsApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Finish an Upload
    # Queues a Task that creates an Artifact, and the Upload gets deleted and cannot be re-used.
    # @param upload_href [String] 
    # @param upload_commit [UploadCommit] 
    # @param [Hash] opts the optional parameters
    # @return [AsyncOperationResponse]
    def commit(upload_href, upload_commit, opts = {})
      data, _status_code, _headers = commit_with_http_info(upload_href, upload_commit, opts)
      data
    end

    # Finish an Upload
    # Queues a Task that creates an Artifact, and the Upload gets deleted and cannot be re-used.
    # @param upload_href [String] 
    # @param upload_commit [UploadCommit] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(AsyncOperationResponse, Integer, Hash)>] AsyncOperationResponse data, response status code and response headers
    def commit_with_http_info(upload_href, upload_commit, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: UploadsApi.commit ...'
      end
      # verify the required parameter 'upload_href' is set
      if @api_client.config.client_side_validation && upload_href.nil?
        fail ArgumentError, "Missing the required parameter 'upload_href' when calling UploadsApi.commit"
      end
      # verify the required parameter 'upload_commit' is set
      if @api_client.config.client_side_validation && upload_commit.nil?
        fail ArgumentError, "Missing the required parameter 'upload_commit' when calling UploadsApi.commit"
      end
      # resource path
      local_var_path = '{upload_href}commit/'.sub('{' + 'upload_href' + '}', CGI.escape(upload_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] || @api_client.object_to_http_body(upload_commit) 

      # return_type
      return_type = opts[:return_type] || 'AsyncOperationResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:POST, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: UploadsApi#commit\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Create an upload
    # View for chunked uploads.
    # @param upload [Upload] 
    # @param [Hash] opts the optional parameters
    # @return [UploadResponse]
    def create(upload, opts = {})
      data, _status_code, _headers = create_with_http_info(upload, opts)
      data
    end

    # Create an upload
    # View for chunked uploads.
    # @param upload [Upload] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(UploadResponse, Integer, Hash)>] UploadResponse data, response status code and response headers
    def create_with_http_info(upload, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: UploadsApi.create ...'
      end
      # verify the required parameter 'upload' is set
      if @api_client.config.client_side_validation && upload.nil?
        fail ArgumentError, "Missing the required parameter 'upload' when calling UploadsApi.create"
      end
      # resource path
      local_var_path = '/pulp/api/v3/uploads/'

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] || @api_client.object_to_http_body(upload) 

      # return_type
      return_type = opts[:return_type] || 'UploadResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:POST, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: UploadsApi#create\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Delete an upload
    # View for chunked uploads.
    # @param upload_href [String] 
    # @param [Hash] opts the optional parameters
    # @return [nil]
    def delete(upload_href, opts = {})
      delete_with_http_info(upload_href, opts)
      nil
    end

    # Delete an upload
    # View for chunked uploads.
    # @param upload_href [String] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(nil, Integer, Hash)>] nil, response status code and response headers
    def delete_with_http_info(upload_href, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: UploadsApi.delete ...'
      end
      # verify the required parameter 'upload_href' is set
      if @api_client.config.client_side_validation && upload_href.nil?
        fail ArgumentError, "Missing the required parameter 'upload_href' when calling UploadsApi.delete"
      end
      # resource path
      local_var_path = '{upload_href}'.sub('{' + 'upload_href' + '}', CGI.escape(upload_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: UploadsApi#delete\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # List uploads
    # View for chunked uploads.
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :limit Number of results to return per page.
    # @option opts [Integer] :offset The initial index from which to return the results.
    # @option opts [String] :ordering Which field to use when ordering the results.
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [PaginatedUploadResponseList]
    def list(opts = {})
      data, _status_code, _headers = list_with_http_info(opts)
      data
    end

    # List uploads
    # View for chunked uploads.
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :limit Number of results to return per page.
    # @option opts [Integer] :offset The initial index from which to return the results.
    # @option opts [String] :ordering Which field to use when ordering the results.
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [Array<(PaginatedUploadResponseList, Integer, Hash)>] PaginatedUploadResponseList data, response status code and response headers
    def list_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: UploadsApi.list ...'
      end
      # resource path
      local_var_path = '/pulp/api/v3/uploads/'

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'limit'] = opts[:'limit'] if !opts[:'limit'].nil?
      query_params[:'offset'] = opts[:'offset'] if !opts[:'offset'].nil?
      query_params[:'ordering'] = opts[:'ordering'] if !opts[:'ordering'].nil?
      query_params[:'fields'] = opts[:'fields'] if !opts[:'fields'].nil?
      query_params[:'exclude_fields'] = opts[:'exclude_fields'] if !opts[:'exclude_fields'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'PaginatedUploadResponseList' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: UploadsApi#list\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Inspect an upload
    # View for chunked uploads.
    # @param upload_href [String] 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [UploadDetailResponse]
    def read(upload_href, opts = {})
      data, _status_code, _headers = read_with_http_info(upload_href, opts)
      data
    end

    # Inspect an upload
    # View for chunked uploads.
    # @param upload_href [String] 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [Array<(UploadDetailResponse, Integer, Hash)>] UploadDetailResponse data, response status code and response headers
    def read_with_http_info(upload_href, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: UploadsApi.read ...'
      end
      # verify the required parameter 'upload_href' is set
      if @api_client.config.client_side_validation && upload_href.nil?
        fail ArgumentError, "Missing the required parameter 'upload_href' when calling UploadsApi.read"
      end
      # resource path
      local_var_path = '{upload_href}'.sub('{' + 'upload_href' + '}', CGI.escape(upload_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'fields'] = opts[:'fields'] if !opts[:'fields'].nil?
      query_params[:'exclude_fields'] = opts[:'exclude_fields'] if !opts[:'exclude_fields'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'UploadDetailResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: UploadsApi#read\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Upload a file chunk
    # Upload a chunk for an upload.
    # @param content_range [String] The Content-Range header specifies the location of the file chunk within the file.
    # @param upload_href [String] 
    # @param file [File] A chunk of the uploaded file.
    # @param [Hash] opts the optional parameters
    # @option opts [String] :sha256 The SHA-256 checksum of the chunk if available.
    # @return [UploadResponse]
    def update(content_range, upload_href, file, opts = {})
      data, _status_code, _headers = update_with_http_info(content_range, upload_href, file, opts)
      data
    end

    # Upload a file chunk
    # Upload a chunk for an upload.
    # @param content_range [String] The Content-Range header specifies the location of the file chunk within the file.
    # @param upload_href [String] 
    # @param file [File] A chunk of the uploaded file.
    # @param [Hash] opts the optional parameters
    # @option opts [String] :sha256 The SHA-256 checksum of the chunk if available.
    # @return [Array<(UploadResponse, Integer, Hash)>] UploadResponse data, response status code and response headers
    def update_with_http_info(content_range, upload_href, file, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: UploadsApi.update ...'
      end
      # verify the required parameter 'content_range' is set
      if @api_client.config.client_side_validation && content_range.nil?
        fail ArgumentError, "Missing the required parameter 'content_range' when calling UploadsApi.update"
      end
      # verify the required parameter 'upload_href' is set
      if @api_client.config.client_side_validation && upload_href.nil?
        fail ArgumentError, "Missing the required parameter 'upload_href' when calling UploadsApi.update"
      end
      # verify the required parameter 'file' is set
      if @api_client.config.client_side_validation && file.nil?
        fail ArgumentError, "Missing the required parameter 'file' when calling UploadsApi.update"
      end
      # resource path
      local_var_path = '{upload_href}'.sub('{' + 'upload_href' + '}', CGI.escape(upload_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['multipart/form-data', 'application/x-www-form-urlencoded'])
      header_params[:'Content-Range'] = content_range

      # form parameters
      form_params = opts[:form_params] || {}
      form_params['file'] = file
      form_params['sha256'] = opts[:'sha256'] if !opts[:'sha256'].nil?

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'UploadResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:PUT, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: UploadsApi#update\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
